unit Main;

interface

uses
  Windows, Classes, Controls, Graphics, Forms, ComCtrls, StdCtrls, ShDocVW,
  IESnifferAutoFill, IESnifferAutoFillUserInfo, IEClasses, AwayTimer,
  IESniffer;

type
  TMainForm = class(TForm)
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    ListView1: TListView;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    GroupBox3: TGroupBox;
    KeywordsEdit: TEdit;
    MarkBtn: TButton;
    ClearBtn: TButton;
    GroupBox4: TGroupBox;
    ConfigBtn: TButton;
    AutoFillBtn: TButton;
    IESniffer1: TIESniffer;
    IESnifferAutoFillUserInfo1: TIESnifferAutoFillUserInfo;
    procedure IESniffer1WindowLoad(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; State: TacWindowLoadState);
    procedure IESniffer1WindowUnload(Sender: TObject; const URL: String);
    procedure IESniffer1WBBeforeNavigate2(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure IESniffer1WBCommandStateChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2; Command: Integer;
      Enable: WordBool);
    procedure IESniffer1WBDocumentComplete(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL: OleVariant);
    procedure IESniffer1WBDownloadBegin(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2);
    procedure IESniffer1WBDownloadComplete(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2);
    procedure IESniffer1WBFullScreen(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; FullScreen: WordBool);
    procedure IESniffer1WBMenuBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; MenuBar: WordBool);
    procedure IESniffer1WBNavigateComplete2(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL: OleVariant);
    procedure IESniffer1WBNewWindow2(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure IESniffer1WBProgressChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2; Progress,
      ProgressMax: Integer);
    procedure IESniffer1WBPropertyChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const szProperty: WideString);
    procedure IESniffer1WBQuit(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2);
    procedure IESniffer1WBStatusBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; StatusBar: WordBool);
    procedure IESniffer1WBStatusTextChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      var Text: WideString);
    procedure IESniffer1WBTheaterMode(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; TheaterMode: WordBool);
    procedure IESniffer1WBTitleChange(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; const Text: WideString);
    procedure IESniffer1WBToolBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; ToolBar: WordBool);
    procedure IESniffer1WBVisible(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; Visible: WordBool);
    procedure IESniffer1URLChange(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2);
    procedure MarkBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure ConfigBtnClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure AutoFillBtnClick(Sender: TObject);
    procedure GroupBox4Click(Sender: TObject);
  private
  public
    procedure Log(const St, URL: String);
    procedure RefreshActiveInstancesView;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses AutoFillForm;

procedure TMainForm.Log(const St, URL: String);
begin
  ListBox1.Items.Add(St + ': ' + URL);
  ListBox1.ItemIndex := ListBox1.Items.Count - 1;
end;

procedure TMainForm.RefreshActiveInstancesView;
var
  I: Integer;
  ListItem: TListItem;
begin
  with ListView1, Items do
   try
     BeginUpdate;
     Clear;

     I := IESniffer1.IEList.Count;
     if I <> 0 then
      for I := 0 to I - 1 do
       with IESniffer1, IEList[I] do
        try
          ListItem := ListView1.Items.Add;
          ListItem.Data := IEList[I];
          ListItem.Caption := URL;
          ListItem.SubItems.Add(Browser.LocationName);
        except
        end;
   finally
     EndUpdate;
   end;
end;

procedure TMainForm.IESniffer1WindowLoad(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; State: TacWindowLoadState);
const
  StateStr: Array[TacWindowLoadState] of String = ('Exists Loading', 'Exists Completed', 'New Loading', 'New Completed');
begin
  Log(StateStr[State], URL);
  RefreshActiveInstancesView;
end;

procedure TMainForm.IESniffer1WindowUnload(Sender: TObject;
  const URL: String);
begin
  Log('Unload', URL);
end;

procedure TMainForm.IESniffer1WBBeforeNavigate2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
begin
  Log('BeforeNavigate2 to', NewURL);
end;

procedure TMainForm.IESniffer1WBCommandStateChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; Command: Integer;
  Enable: WordBool);
begin
  Log('CommandStateChange', URL);
end;

procedure TMainForm.IESniffer1WBDocumentComplete(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL: OleVariant);
begin
  Log('DocumentComplete', NewURL);
end;

procedure TMainForm.IESniffer1WBDownloadBegin(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2);
begin
  Log('DownloadBegin', URL);
end;

procedure TMainForm.IESniffer1WBDownloadComplete(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2);
begin
  Log('DownloadComplete', URL);
//  IEMarkText(Browser, 'Delphi', clBlack, clYellow);
end;

procedure TMainForm.IESniffer1WBFullScreen(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; FullScreen: WordBool);
begin
  Log('FullScreen', URL);
end;

procedure TMainForm.IESniffer1WBMenuBar(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; MenuBar: WordBool);
begin
  Log('MenuBar', URL);
end;

procedure TMainForm.IESniffer1WBNavigateComplete2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL: OleVariant);
begin
  Log('NavigateComplete', NewURL);
end;

procedure TMainForm.IESniffer1WBNewWindow2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; var ppDisp: IDispatch;
  var Cancel: WordBool);
begin
  Log('NewWindow2', URL);
end;

procedure TMainForm.IESniffer1WBProgressChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; Progress,
  ProgressMax: Integer);
begin
  Log('ProgressChange', URL);
end;

procedure TMainForm.IESniffer1WBPropertyChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2;
  const szProperty: WideString);
begin
  Log('PropertyChange', URL);
end;

procedure TMainForm.IESniffer1WBQuit(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2);
begin
  Log('Quit', URL);
  RefreshActiveInstancesView;  
end;

procedure TMainForm.IESniffer1WBStatusBar(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; StatusBar: WordBool);
begin
  Log('StatusBar', URL);
end;

procedure TMainForm.IESniffer1WBStatusTextChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; var Text: WideString);
begin
  StatusBar1.SimpleText := Text;
end;

procedure TMainForm.IESniffer1WBTheaterMode(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; TheaterMode: WordBool);
begin
  Log('TheaterMode', URL);
end;

procedure TMainForm.IESniffer1WBTitleChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const Text: WideString);
begin
  Log('TitleChange', URL);
  RefreshActiveInstancesView;  
end;

procedure TMainForm.IESniffer1WBToolBar(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; ToolBar: WordBool);
begin
  Log('ToolBar', URL);
end;

procedure TMainForm.IESniffer1WBVisible(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; Visible: WordBool);
begin
  Log('Visible', URL);
end;

procedure TMainForm.IESniffer1URLChange(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2);
begin
  Log('URL Changed', URL);
  RefreshActiveInstancesView;  
end;

procedure TMainForm.MarkBtnClick(Sender: TObject);
var
  I: Integer;
begin
  I := IESniffer1.IEList.Count;
  if I <> 0 then
   for I := 0 to I - 1 do // enumerate Browser windows
    with IESniffer1.IEList[I] do
     if IsReady then // if it ready to be modified
      IEMarkKeywords(Browser, KeywordsEdit.Text, ' ');
end;

procedure TMainForm.ClearBtnClick(Sender: TObject);
var
  I: Integer;
begin
  I := IESniffer1.IEList.Count;
  if I <> 0 then
   for I := 0 to I - 1 do // enumerate Browser windows
    with IESniffer1.IEList[I] do
     if IsReady then // if it ready to be modified
      IEClearMarks(Browser);
end;

procedure TMainForm.ConfigBtnClick(Sender: TObject);
begin
  with TAutoFillFrm.Create(Application) do
   try
     AutoFillUserInfo := IESnifferAutoFillUserInfo1;
     ShowModal;
   finally
     Free;
   end;
end;

procedure TMainForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  AutoFillBtn.Enabled := ListView1.Selected <> nil;
end;

procedure TMainForm.AutoFillBtnClick(Sender: TObject);
var
  IEItem: TIEHelper;
begin
  if (ListView1.Selected <> nil) and (ListView1.Selected.Data <> nil) then
   begin
    IEItem := ListView1.Selected.Data;
    IESnifferAutoFillUserInfo1.Fill(IEItem.Browser);
   end;
end;

procedure TMainForm.GroupBox4Click(Sender: TObject);
var
  IEItem: TIEHelper;
begin
  if (ListView1.Selected <> nil) and (ListView1.Selected.Data <> nil) then
   begin
    IEItem := ListView1.Selected.Data;
    IEItem.ZoomFactor := 150;
   end;
end;

end.
